//
//
//

#ifndef EXECUTOR_VM
#define EXECUTOR_VM

void 
Xvm::Init(){
	Jump=0;
	type=0;
};

void 
Xvm::DetermComm()
  {
    char* comm;
    comm=CurComm;
    if(*comm!='\0')
      {
	char* temp;
	static char tempstr[MAX_XVM_COMM_LEN];
	char* temp2=tempstr;
	char* ts;
	int parse=0;
	ts=comm;
	while((*ts!='(' && *ts!='\0') && *ts!=')')
	  {
	    ts++;
	  };
	if(*ts=='(')
	  {
	    parse++;
	    ts++;
	  };
	while((*ts!='(' && *ts!='\0') && *ts!=')')
	  {
	    ts++;
	  };
	if(*ts==')')
	  {
	    parse++;
	    ts++;
	  };
	if(parse==2)
	  {
	    strcpy(temp2,comm);
	    temp=strtok(temp2," (");
	    switch(*temp)
	      {
		  case 'Z':
		  case 'z':
		    type=1;
		  break;
		  case 'S':
		  case 's':
		    type=2;
		  break;
		  case 'T':
		  case 't':
		    type=3;
		  break;
		  case 'J':
		  case 'j':
		    type=4;
		  break;
		  default :
		    type=-1;
		    StopProg(XVM_ERRORSTOP);
		    ErrorType=XVM_ERRT_UNKNOWNCOMM;
		    Error=XVM_ERRM_UNKNOWNCOMM;
	      };
	  }
	else
	  {
	    type=-1;
	    StopProg(XVM_ERRORSTOP);
	    ErrorType=XVM_ERRT_PARSEERR;
	    Error=XVM_ERRM_PARSEERR;
  	  };
      }
    else
      {
	type=0;
      };
  };

void 
Xvm::ExtractArgs(char* comm){
	//char* args[3];
	static char buf[MAX_XVM_COMM_LEN];
	char* temp=buf;
	strcpy(temp,comm);
	strtok(temp,"(");
	Args[0]=strtok(NULL,",)");
	Args[1]=strtok(NULL,",)");
	Args[2]=strtok(NULL,")");
};

void 
Xvm::DExtractArgs(){
	static char buf[MAX_XVM_COMM_LEN];
	char* temp=buf;
	strcpy(temp,CurComm);
	strtok(temp,"(");
	Args[0]=strtok(NULL,",)");
	Args[1]=strtok(NULL,",)");
	Args[2]=strtok(NULL,")");
};

void
Xvm::ResolvArgs(char* args[3]){
	if(type==1 && (args[0]==NULL || args[1]!=NULL || args[2]!=NULL)){
		type=-1;
		StopProg(XVM_ERRORSTOP);
		ErrorType=XVM_ERRT_INSUFFARGS;
		Error="Insufficient number of arguments in Z(REG)";
	};
	if(type==2 && (args[0]==NULL || args[1]!=NULL || args[2]!=NULL)){
		type=-1;
		StopProg(XVM_ERRORSTOP);
		ErrorType=XVM_ERRT_INSUFFARGS;
		Error="Insufficient number of arguments in S(REG)";
	};
	if(type==3 && (args[0]==NULL || args[1]==NULL || args[2]!=NULL)){
		type=-1;
		StopProg(XVM_ERRORSTOP);
		ErrorType=XVM_ERRT_INSUFFARGS;
		Error="Insufficient number of arguments in T(FROM,TO)";
	};
	if(type==4 && (args[0]==NULL || args[1]==NULL || args[2]==NULL)){
		type=-1;
		StopProg(XVM_ERRORSTOP);
		ErrorType=XVM_ERRT_INSUFFARGS;
		Error="Insufficient number of arguments in J(REG1,REG2,TOJUMP)";
	};
};

void
Xvm::DResolvArgs()
  {
    if(type==1 && (Args[0]==NULL || Args[1]!=NULL || Args[2]!=NULL))
      {
	type=-1;
	StopProg(XVM_ERRORSTOP);
	ErrorType=XVM_ERRT_INSUFFARGS;
	Error="Insufficient number of arguments in Z(REG)";
      };
    if(type==2 && (Args[0]==NULL || Args[1]!=NULL || Args[2]!=NULL))
      {
	type=-1;
	StopProg(XVM_ERRORSTOP);
	ErrorType=XVM_ERRT_INSUFFARGS;
	Error="Insufficient number of arguments in S(REG)";
      };
    if(type==3 && (Args[0]==NULL || Args[1]==NULL || Args[2]!=NULL))
      {
	type=-1;
	StopProg(XVM_ERRORSTOP);
	ErrorType=XVM_ERRT_INSUFFARGS;
	Error="Insufficient number of arguments in T(FROM,TO)";
      };
    if(type==4 && (Args[0]==NULL || Args[1]==NULL || Args[2]==NULL))
      {
	type=-1;
	StopProg(XVM_ERRORSTOP);
	ErrorType=XVM_ERRT_INSUFFARGS;
	Error="Insufficient number of arguments in J(REG1,REG2,TOJUMP)";
      };
    if(type==XVM_STATT_Z || type==XVM_STATT_S)
      {
	DArg1=atoi(Args[0]);
	DArg2=0;
	DArg3=0;
      };
    if(type==XVM_STATT_T)
      {
	DArg1=atoi(Args[0]);
	DArg2=atoi(Args[1]);
	DArg3=0;
      };
    if(type==XVM_STATT_J)
      {
	DArg1=atoi(Args[0]);
	DArg2=atoi(Args[1]);
	DArg3=atoi(Args[2]);
      };
    if(DArg1>GetRegListLen() || DArg1<0 || DArg2>GetRegListLen() || DArg2<0 ||
        DArg3>GetRegListLen() || DArg3<0)
      {
        type=-1;
        StopProg(XVM_ERRORSTOP);
        ErrorType=XVM_ERRT_OUTOFRANGE;
        Error=XVM_ERRM_OUTOFRANGE;
      };
  };

int 
Xvm::ProcessComm(char* args[3]){
	//comm="";
	switch(type){
	case -1:
	break;
	case 1:
		ExZeroReg(atoi(args[0]));
		break;
	case 2:
		ExIncReg(atoi(args[0]));
		break;
	case 3:
		ExMovReg(atoi(args[0]),atoi(args[1]));
		break;
	case 4:
		ExJump(atoi(args[0]),atoi(args[1]),atoi(args[2]));
		break;
	case 0:
		StopProg(XVM_STOPED);
		break;
	default:
		StopProg(XVM_ERRORSTOP);
		ErrorType=XVM_ERRT_UNKNOWNCOMM;
		Error="Unknown statement";
	};
	return 1;
};

void 
Xvm::DProcessComm()
  {
    register temp;
    temp=type;
    if(temp==XVM_STATT_S)
      {
	ExDIncReg(DArg1);
	return;
      };
    if(temp==XVM_STATT_J)
      {
	ExDJump(DArg1,DArg2,DArg3);
	return;
      };
    if(temp==XVM_STATT_Z)
      {
        ExDZeroReg(DArg1);
	return;
      };
    if(temp==XVM_STATT_T)
      {
        ExDMovReg(DArg1,DArg2);
	return;
      };
    if(temp==XVM_STATT_STOP)
      {
	StopProg(XVM_STOPED);
        return;
      };
    StopProg(XVM_ERRORSTOP);
    ErrorType=XVM_ERRT_UNKNOWNCOMM;
    Error=XVM_ERRM_UNKNOWNCOMM;
//fquit: ;
  };

int 
Xvm::ExZeroReg(int reg){
	SetReg(reg,"");
	return 1;
};

int 
Xvm::ExIncReg(int reg){
	SetReg(reg,ItoA(atoi(GetReg(reg))+1));
	return 1;
};

int 
Xvm::ExMovReg(int src,int tgt){
	SetReg(tgt,GetReg(src));
	return 1;
};

int
Xvm::ExJump(int arg1,int arg2, int to){
	if(arg1==arg2){
		Jump=to;
	}
	else{
		if(strcmp(GetReg(arg1),GetReg(arg2))==0){
			Jump=to;
		}
		else{
			Jump=0;
		};
	};
	return 1;
};

void 
Xvm::ExDZeroReg(int reg)
  {
    SetDReg(reg,0);
  };

void 
Xvm::ExDIncReg(int reg)
  {
    SetDReg(reg,GetDReg(reg)+1);
  };

void 
Xvm::ExDMovReg(int src,int tgt)
  {
    SetDReg(tgt,GetDReg(src));
  };

void
Xvm::ExDJump(int arg1,int arg2,int to)
  {
    if(arg1==arg2)
      {
	Jump=to;
      }
    else
      {
	if(GetDReg(arg1)==GetDReg(arg2))
	  {
	    Jump=to;
	  }
	else
	  {
	    Jump=0;
	  };
      };
  };

void
Xvm::VerifyComm()
  {
    register int temp;
    register int temp2;
    register bool temp3;
    temp2=CurCommNo;
    temp=0;
    temp3=FALSE;
    while(temp3==FALSE && temp<MAX_XVM_CASHCOMM)
      {
        if(*(commhead+temp)==temp2)
          {
	    temp3=TRUE;
	  }
	else
	  {
	    temp++;
          };
      };
    if(temp3==TRUE)
      {
        DArg1=CashComm[temp].arg1;
        DArg2=CashComm[temp].arg2;
        DArg3=CashComm[temp].arg3;
        type=CashComm[temp].type;
	CashComm[temp].acces++;
      }
    else
      {
        CurComm=GetComm(CurCommNo);
        DetermComm();
        DExtractArgs();
        DResolvArgs();
        *(commhead+LastCash)=GetCurCommNo();
        CashComm[LastCash].type=type;
        CashComm[LastCash].arg1=DArg1;
        CashComm[LastCash].arg2=DArg2;
        CashComm[LastCash].arg3=DArg3;
        CashComm[LastCash].busy=TRUE;
        if(LastCash==MAX_XVM_CASHCOMM-1)
          {
	    LastCash=0;
          }
        else
          {
	    LastCash++;
	  };
      };
  };

#endif //EXECUTOR_VM	
